/*
 * Copyright (C) 2012-2013 The Dojo Foundation
 * 
 * Copyright (C) 2012-2013 Rex Young
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package com.fastmessenger.impl;

import java.lang.reflect.Method;

class ServiceRequest {

    static private final Object[] EmptyArgs = new Object[0];

    private int returnValueIndex;
    private Address returnAddress, serviceAddress;
    private Object[] returnArguments, serviceArguments;
    private Method serviceMethod;

    ServiceRequest (Address returnAddress, Object[] returnArguments, int returnValueIndex,
            Address serviceAddress, Method serviceMethod, Object[] serviceArguments) {
        setReturnAddress (returnAddress);
        setReturnArguments (returnArguments);
        setReturnValueIndex (returnValueIndex);
        setServiceAddress (serviceAddress);
        setServiceMethod (serviceMethod);
        setServiceArguments (serviceArguments);
    }

    int getReturnValueIndex () {
        return returnValueIndex;
    }

    void setReturnValueIndex (int returnValueIndex) {
        this.returnValueIndex = returnValueIndex;
    }

    Address getReturnAddress () {
        return returnAddress;
    }

    void setReturnAddress (Address returnAddress) {
        this.returnAddress = returnAddress;
    }

    Address getServiceAddress () {
        return serviceAddress;
    }

    void setServiceAddress (Address serviceAddress) {
        this.serviceAddress = serviceAddress;
    }

    Object[] getReturnArguments () {
        return returnArguments;
    }

    void setReturnArguments (Object[] returnArguments) {
        this.returnArguments = returnArguments == null ? EmptyArgs : returnArguments;
    }

    Object[] getServiceArguments () {
        return serviceArguments;
    }

    void setServiceArguments (Object[] serviceArguments) {
        this.serviceArguments = serviceArguments == null ? EmptyArgs : serviceArguments;
    }

    Method getServiceMethod () {
        return serviceMethod;
    }

    void setServiceMethod (Method serviceMethod) {
        this.serviceMethod = serviceMethod;
    }

}
