/*
 * Copyright (C) 2012-2013 The Dojo Foundation
 * 
 * Copyright (C) 2012-2013 Rex Young
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package com.fastmessenger.impl;

class SwtReceiverMailbox extends ReceiverMailbox {

    SwtReceiverMailbox (GuiMessenger messenger, Object[] implObjs) {
        super (messenger, implObjs);
    }

    void addServiceRequest (final ServiceRequest request) {
        synchronized (lockObj) {
            if (mailboxRunning) {

                ((GuiMessenger) messenger).getSwtDisplay ().asyncExec (new Runnable () {

                    public void run () {
                        synchronized (lockObj) {
                            if (!mailboxRunning) {
                                return;
                            }
                        }
                        executeServiceRequest (headcounts[0], request);
                    }
                });
            }
        }
    }

}
